library ac_dart.example.config;

import 'package:atlassian_connect_shelf/src/config/config.dart';
import 'package:config/config.dart';
import 'package:mojito/mojito.dart';
import 'package:quiver/core.dart';

class ExampleAppConfig extends Config<ExampleAppConfig> {
  final ClientId bitbucketOauthClientId;

  ExampleAppConfig(this.bitbucketOauthClientId);

  ClientId get bbOauthFromEnv => new ClientId(
      fromEnvironment('BB_OAUTH_CLIENT_ID'),
      fromEnvironment('BB_OAUTH_SECRET'));

  @override
  ExampleAppConfig merge(ExampleAppConfig other) =>
      new ExampleAppConfig(firstNonNull(other.bitbucketOauthClientId,
          bitbucketOauthClientId, bbOauthFromEnv));
}

// TODO: should be able to default all this right???
// could make it like app.router.addons(repoConfig: myRepoConfig)
final config = new ConfigFactory.standard(
    new AcDartConfig(server: new AcDartServerConfig(serverPort: 1234)),
    development: () => new AcDartConfig(
        server: new AcDartServerConfig.development(),
        app: new ExampleAppConfig(new ClientId(
            'qX3naeTT4TjQRm8YQB', 'Zw8zLd2Up9nfXjK327JrMgAeau2d1jwM'))),
    production: () => new AcDartConfig());

// TODO: MojitoServerConfig allows createRootRouter to be overridden but
// acdart needs to override this itself
