library ac_dart.example.example_addon;

import 'package:atlassian_connect_shelf/atlassian_connect_shelf.dart';
import 'package:logging/logging.dart';
import 'package:uuid/uuid.dart';
import 'dart:io';
import 'package:path/path.dart' as p;

final Logger _log = new Logger('ac_dart.example.app');

main() async {
  final addonKey = 'foo-bar-addon';
  final ngrokSubdomain = '$addonKey-dev';

  Logger.root.level = Level.ALL;

  final app = init(
      'https://$ngrokSubdomain.ngrok.com',
      new AcDartHostRepoConfig.localFile(new File(p.join(
          Directory.systemTemp.path, 'test-registrations-$addonKey.json'))),
      isDevMode: () => true,
      startNgrok: true,
      ngrokSubdomain: ngrokSubdomain);

//  Logger.root.level = Level.ALL;

  final vendor =
      new Vendor(name: 'gaggle', url: Uri.parse('http://example.com'));

  app.router.addons.bitbucket(
      addonKey,
      (_) => new ClientId(
          'qXAnayTT4TjQRm8YQB', 'Zw8zLd2Up9nfXjK327JrMgAeau2d1jwM'),
      addonSecret: new Uuid().v4())
    ..addDescriptorRoute(vendor, 'Foo', 'Sooooo exciiting',
        scopes: [bitbucketScopes.repository.basic])
    ..addInstallationRoute()
    ..addSpaRepoPage('spa/myRepoPage', 'myRepoPage', 'my awesome repo page',
        bitbucket.repository.navigation);

  app.start();
}
